%{
/*
 * scanner.l --
 *
 *  Last Modified: Tue Oct 31 16:43:34 1995 by Bryan M. Kramer
 *
 * Copyright (c) 1990-1994 University of Toronto.
 * All rights reserved.
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that the
 * above copyright notice and the following two paragraphs appear in
 * all copies of this software.
 *
 * IN NO EVENT SHALL THE UNIVERSITY OF Toronto BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * Toronto HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * THE UNIVERSITY OF Toronto SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF Toronto HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 */

#include <string.h>
#undef YYLMAX
#define YYLMAX 50000 /* this should be fixed in lex by making it use malloc() */
                    /* see the protptype file /usr/ccs/lib/lex/ncform */

extern YYSTYPE yylval;
extern int parsing_goal;

# undef input
# undef unput

# define input() (use_string ? ((string_pos < string_len) ? input_string[string_pos++] : 0) : (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar))

# define unput(cc) {if (use_string) { yytchar= (cc); if (yytchar) {string_pos--; }} else {yytchar= (cc);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}}


%}
%p 5010
%n 600
%a 12000
%o 7000

%%

\"\[   { return START_SEQ; }
\]\"   { return END_SEQ; }



Goal { if (parsing_goal)
	{yylval.sval = "Goal"; parsing_goal = 0; return TP_GOAL; }
       else
	{yylval.sval = "Goal"; return TP_IDENTIFIER; }
    }
GOAL { if (parsing_goal)
	{yylval.sval = "Goal"; parsing_goal = 0; return TP_GOAL; }
       else
	{yylval.sval = "GOAL"; return TP_IDENTIFIER; }
    }
goal { if (parsing_goal)
	{yylval.sval = "Goal"; parsing_goal = 0; return TP_GOAL; }
       else
	{yylval.sval = "goal"; return TP_IDENTIFIER; }
    }
Rule { yylval.sval = "Rule"; return TP_RULE; }
rule { yylval.sval = "rule"; return TP_RULE; }
RULE { yylval.sval = "RULE"; return TP_RULE; }
Not { yylval.sval = "Not"; return TP_NOT; }
not { yylval.sval = "not"; return TP_NOT; }
NOT { yylval.sval = "NOT"; return TP_NOT; }
Token { yylval.sval = "Token"; return TP_TOKEN; }
Class { return TP_SCLASS; }
SimpleClass { return TP_SCLASS; }
MetaClass { return TP_M1CLASS; }
MetaMetaClass { return TP_M2CLASS; }
MMClass { return TP_M2CLASS; }
instance { return INSTANCE; }
slot { return SLOT; }
in { return TP_IN; }
In { return TP_IN; }
IN { return TP_IN; }
isA { return TP_ISA; }
isa { return TP_ISA; }
IsA { return TP_ISA; }
ISA { return TP_ISA; }
with { return TP_WITH; }
With { return TP_WITH; }
WITH { return TP_WITH; }
nil { return TP_nil; }
Nil { return TP_nil; }
NIL { return TP_nil; }
END { return TP_END; }
End { return TP_END; }
end { return TP_END; }
\$  	{ return TP_DOLLAR; }
=  	{ return TP_EQUAL; }
[0-9]+\.[0-9]+ { yylval.sval = strdup(yytext); return TP_OBJECT; }
[0-9]+	{ yylval.sval = strdup(yytext); return TP_OBJECT; }
-[0-9]+	{ yylval.sval = strdup(yytext); return TP_OBJECT; }
[?A-Za-z_0-9-]+	{ yylval.sval = strdup(yytext) ; return TP_IDENTIFIER; }
\,  	{ return TP_COMMA; }
\;  	{ return TP_SEMICOLON; }
\:  	{ return TP_COLON; }
\/  	{ return TP_SLASH; }


\|[^|]*\|	{ yytext[strlen(yytext)-1] = 0; yylval.sval = strdup(yytext+1) ; return TP_IDENTIFIER; }



\"[^[\"][^\"]*\"	
{
    if (yytext[yyleng - 1] == '\\')
	yymore();
    else {
        int len;
	len = strlen(yytext);
	yylval.sval = malloc(sizeof(char *) * (len + 1));
        strncpy((char*)yylval.sval, yytext, len);
        ((char*)(yylval.sval))[len] = 0;
	return TP_STRING;
    }
}

\"\" { yylval.sval = strdup ("\"\""); return TP_STRING; }

\/\/.*$	;
#.*$	;
[ \t\n]	;
\(\*.*$ ;


\(	{ return LBRACKET; }
\)	{ return RBRACKET; }
\{	{ return LBRACE; }
\}	{ return RBRACE; }


\"\[   { return START_SEQ; }
\]\"   { return END_SEQ; }

%%

